# -*- coding: iso_8859_1 -*-

from aspylib import cdr, astro
import numpy as np
import matplotlib.pyplot as plt

#------------------------------------------------------------------------------------
#	input parameters
#------------------------------------------------------------------------------------

#--- input files ---
Folder = u"C:\\Mesures\\"
Filelist = ["File_1.txt", \
			"File_2.txt", \
			"File_3.txt"]

Filelist = [Folder + x for x in Filelist]

#fit parameters
T0 = 2455806.4
period = 0.05

#for time correction
alpha = astro.hours_to_decdegrees('03:09:39.67')
delta = astro.degrees_to_decdegrees('+24:29:26.9')

#------------------------------------------------------------------------------------
#	loading data
#------------------------------------------------------------------------------------

alldata = cdr.load_magdata(Filelist)
#alldata = cdr.time_correction(alldata, 1, Folder+'dist.dat')
alldata = cdr.time_correction(alldata, 2, [alpha,delta])

cdr.plot_magdata(alldata, 'Measurements (Sept. 2011)')

#------------------------------------------------------------------------------------
#	fitting data
#------------------------------------------------------------------------------------

popt, pcov, period, dperiod, amplitude, maxdate, mindate = cdr.fit_CDR(alldata, period, T0, nb_harmo = 3, show_results = True, show_plot = True)
plt.ylim([-0.251,0.251])
plt.title('Lightcurve with its Fourier fit')
plt.show()

#------------------------------------------------------------------------------------
#	generating phase ephemerid
#------------------------------------------------------------------------------------

if False:

	JJ = np.linspace(2455822.5, 2455842.5, 241)
	print
	print "------ phase ephemerids ------"	
	phase = (JJ-T0)/popt[0]-np.floor((JJ-T0)/popt[0])

	for i,dd in enumerate(JJ):
		print dd, phase[i]

raw_input("Press Enter")
