# -*- coding: iso_8859_1 -*-

import numpy as np
import scipy.spatial.distance as ds
#from sklearn.metrics import pairwise
from ctypes import *

def slice_it(li, cols):
    start = 0
    for i in xrange(cols):
        stop = start + len(li[i::cols])
        yield li[start:stop]
        start = stop
		
def matching_pairs2(stars, trans, distcrit):

	if len(stars)>100000:
		order = 1000
	elif len(stars)>10000:
		order = 100
	elif len(stars)>1000:
		order = 10
	else:
		order = 1

	stars_ind = np.arange(len(stars))
	sliced_ind = list(slice_it(stars_ind,order))

	for i,list_ind in enumerate(sliced_ind):

		#--- euclidian distance between two sets, for each pair ---
		#dist = pairwise.euclidean_distances(stars[list_ind,:],trans)
		dist = ds.cdist(stars[list_ind,:],trans)		
		match = dist.argmin(axis=1)
		test = np.min(dist,axis=1)<distcrit
		
		if i==0:
			x = list_ind[test]
			y = match[test]
		else:
			x = np.hstack([x,list_ind[test]])
			y = np.hstack([y,match[test]])
	
	#dist = ds.cdist(stars,trans)
	#test = np.min(dist,axis=1)<5
	#match = dist.argmin(axis=1)
	
	return x,y

def matching_pairs(stars, trans, distcrit):

	#distcrit is the distance in pixels used as the criterion
	
	c_double_p = POINTER(c_double)

	x1 = stars[:,0].astype(np.double)
	x1p = x1.ctypes.data_as(POINTER(c_double_p))

	y1 = stars[:,1].astype(np.double)
	y1p = y1.ctypes.data_as(POINTER(c_double_p))

	x2 = trans[:,0].astype(np.double)
	x2p = x2.ctypes.data_as(POINTER(c_double_p))

	y2 = trans[:,1].astype(np.double)
	y2p = y2.ctypes.data_as(POINTER(c_double_p))

	pairs = c_int * max(len(stars),len(trans)) 
	z1=pairs()
	z2=pairs()
	
	dim = c_int()
	
	cdll.astrometry.matching_pairs(c_double(distcrit), len(stars),x1p, y1p, len(trans), x2p, y2p, byref(dim), byref(z1), byref(z2))
	
	x = []
	x[:] = z1[:dim.value]
	y = []
	y[:] = z2[:dim.value]

	return np.array(x),np.array(y)
