# -*- coding: iso_8859_1 -*-
"""
	This module is part of AsPyLib version 1.2.0
    Copyright (C) 2012 Jerome Caron
	
    AsPyLib is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
"""
#------------------------------------------------------------------------------------------------------------
#		aspylib.photometry = module for aperture photometry
#------------------------------------------------------------------------------------------------------------

if ~('aspylib_license' in globals()):
	import aspylib.license
	
from photometry1 import check_pictures_quality
#def check_pictures_quality(Imagelist, outputname):

from photometry2 import calculate_shifts
#def calculate_shifts(Imagelist, outputname, detection_area = 10, nb_stars = 12):

from photometry3 import make_photometry, aperture_photometry
#def make_photometry(Imagelist, sizes, xy, method='centroid', error_messages = 1):
#def aperture_photometry(image, sizes, coord, method='centroid', error_messages = 1):

from photometry4 import findintegershift_crosscorrelation
#def findintegershift_crosscorrelation(image1, image2, excluded = []):

#------------------------------------------------------------------------------------------------------------
from photo_script1 import select_stars
#def select_stars(Imagelist, shifts, outputname, detection_area = 10, method='centroid'):

from photo_script2 import write_magnitudes
#def write_magnitudes(Imagelist, outputname, names, xy, dateobs, sizes, mag):

from photo_script3 import check_refstars
#def check_refstars(names, mag):

from photo_script4 import filter_magnitudes
#def filter_magnitudes(obj_index, names, sizes, mag, rejdata):

from photo_script5 import calc_noise, best_magnitude
#def calc_noise(mag):
#def best_magnitude(obj_index, names, sizes, mag, rejstar, rejdata_i, rejdisk_i, nb=10):

from photo_script6 import write_best_magnitude
#def write_best_magnitude(outputname, Imagelist, names, obj_index, sizes, ref_1, mag_1, sig_1, dateobs, nb=10, rejdata = [], rejsizes = [], rejstar = []):

from photo_script7 import write_cdrcdl_report
#def write_cdrcdl_report(outputname, Imagelist, names, obj_index, mag, ref_1, dateobs, rejdata = []):

#------------------------------------------------------------------------------------------------------------
from automatic_script1 import write_auto_magnitudes
#def write_auto_magnitudes(Imagelist, dateobs, xy, sizes, mag, stats, quality_flag, ref_stars, outputname):

from automatic_script2 import compute_statistics
#def compute_statistics(mag, nbref = 20, plotting = False):

del photometry1, photometry2, photometry3, photometry4
del photo_script1, photo_script2, photo_script3, photo_script4, photo_script5, photo_script6, photo_script7
del automatic_script1, automatic_script2
