# -*- coding: iso_8859_1 -*-

import os, datetime

def write_magnitudes(Imagelist, outputname, names, xy, dateobs, sizes, mag):
	
	if os.path.exists(outputname):
		os.remove(outputname)

	f = open(outputname, 'w')

	#--- file header ---
	f.write('date = '+str((datetime.datetime.now()).strftime("%Y-%m-%d %H:%M:%S"))+'\n')
	f.write("Working directory:\n"+(os.path.split(Imagelist[0])[0]).encode('iso_8859_1')+"\n\n")

	f.write(str(len(Imagelist))+' images processed\n')
	f.write('first image = '+Imagelist[0].split('\\')[-1]+'\n\n')

	#--- stars X,Y coordinates ---
	f.write('objects coordinates\n')
	for j in range(len(xy[0])):
		f.write('X '+names[j]+'\t'+'Y '+names[j]+'\t')
	f.write('\n')
	for i in range(len(Imagelist)):
		for j in range(len(xy[i])):
			f.write(str(xy[i][j][0])+'\t'+str(xy[i][j][1])+'\t')
		f.write('\n')
	f.write('\n')

	#--- measures magnitudes ---
	for k in range(len(sizes)):
		f.write('magnitudes from apertures: '+str(sizes[k][0])+' - '+str(sizes[k][1])+' - '+str(sizes[k][2])+'\n')

		#magnitudes
		f.write('Julian day\t')
		for j in range(len(xy[0])):
			f.write(names[j]+'\t')
		f.write('\n')
		for i in range(len(Imagelist)):
			f.write(('%.6f' % dateobs[i])+'\t')
			for j in range(len(xy[i])):
				f.write(str(mag[i,j,k])+'\t')
			f.write('\n')
		f.write('\n')

	f.close()
	#-------------------------------------