# -*- coding: iso_8859_1 -*-

import numpy as np
import itertools as it 

def calc_noise(mag):
	
	if len(mag)<6:
		result = 'none'
	else:
		x = np.array(mag,dtype=np.float)
		y = x[2:-2] - (x[0:-4]+x[1:-3]+x[2:-2]+x[3:-1]+x[4:])/5.
		result = np.std(y,ddof=0) / np.sqrt(1.-1./5.)
		
	return result

def best_magnitude(obj_index, names, sizes, mag, rejstar, rejdata_i, rejdisk_i, nb=10):

	nb_obs = len([i for i in names if (i[0]=='m')or(i[0]=='v')])  
	nb_ref = len([i for i in names if (i[0]=='r')])  

	#values are the # of the accepted reference stars
	values = np.array([i+1 for i in range(nb_ref) if i+nb_obs not in rejstar], dtype=np.int)
	
	print "optimisation for ", names[obj_index]

	#initialisation
	mag_1 = []
	ref_1 = []
	sig_1 = []
	
	for size in range(len(sizes)):						#loop on apertures
		if size not in rejdisk_i:
			print sizes[size]
			for i in range(len(values)): 						#loop on nb of reference stars chosen
				for j in list(it.combinations(values,i+1)):		#loop on possible combinations of these reference stars
						
					#print names[obj_index],sizes[size],"references stars",j

					mag_2 = []
					for pict in range(len(mag)):						#loop on images
						if pict not in rejdata_i:
							mag_ref = 0.
							for k in range(len(j)):									#loop on reference stars
								mag_ref = mag_ref + mag[pict,nb_obs+j[k]-1,size] / len(j)			#mag[i,j,k] corresponds to image i star j disk k
							mag_2.append(mag[pict,obj_index,size] - mag_ref)

					mag_1.append(mag_2)
					ref_1.append([size, j])
					sig_1.append(calc_noise(mag_2))		#here if there is a single np.nan in the data then sig_2 is also np.nan (due to calc_noise)
														#this trick helps to prevent that there is any np.nan in the data after optimisation
	#pick up best results
	ord = np.argsort(sig_1)
	mag_1 = [mag_1[i] for i in ord[:nb]]
	ref_1 = [ref_1[i] for i in ord[:nb]]
	sig_1 = [sig_1[i] for i in ord[:nb]]
	
	return ref_1, mag_1, sig_1