# -*- coding: iso_8859_1 -*-

from aspylib import astro
import numpy as np
import matplotlib.pyplot as plt
import os.path, datetime
import time

def check_pictures_quality(Imagelist, outputname):

	#------ starting the function -----------------------------------------------------------
	astro.maximize_window(u"C:\\WINDOWS\\system32\\cmd.exe")
	sx, sy = astro.get_window_size(u"C:\\WINDOWS\\system32\\cmd.exe")

	#--- criteria ---
	maxi = []
	mini = []
	dyn = []
	median1 = []
	median2 = []
	median3 = []
	median4 = []

	#--- rejected ---
	rej1 = []
	rej2 = []
	rej3 = []
	
	print
	print '--- CALCULATING STATISTICS ------------------------------------------'

	#--- looping on images ---
	for i in range(len(Imagelist)):
		if i==1:
			t0 = time.time()
		if i==0:
			image0 = astro.get_imagedata([Imagelist[i]])
			
			fig, ax = astro.display(image0, title="First image")
			fx, fy = astro.get_window_position("First image")
			astro.move_window("First image", [sx, fy])
			astro.set_focus(u"C:\\WINDOWS\\System32\\cmd.exe")
			print
			print 'The variations of image dynamic range (max-min values) will be checked.'
			print 'You have the possibility to calculate the min and max values either on the full image (1) or on a smaller area (2) for instance to avoid saturated stars.'
			while 1:
				try:
					ans = int(raw_input('Which one do you choose (1 or 2) ?'))
					break
				except:
					print "please enter an integer !"
			if ans == 1:
				included = []
				plt.close()
			else:
				print 'Right-click on the 4 corners of the area to be used'
				astro.set_focus("First image")
				xy = astro.select(fig,ax,4)
				included = [min([xy[0][0],xy[1][0],xy[2][0],xy[3][0]]), \
							max([xy[0][0],xy[1][0],xy[2][0],xy[3][0]]), \
							min([xy[0][1],xy[1][1],xy[2][1],xy[3][1]]), \
							max([xy[0][1],xy[1][1],xy[2][1],xy[3][1]])] 
				plt.close()
		else:
			image0 = astro.get_imagedata([Imagelist[i]])

		#--- calculating dynamics ---
		image1 = image0
		if len(included)!=0:
			image1 = image1[included[0]:included[1],included[2]:included[3]]

		maxi.append(np.max(image1.flatten()))
		mini.append(np.min(image1.flatten()))
		dyn.append(maxi[-1]-mini[-1])
		
		#--- calculating background uniformity ---
		sizeX = np.shape(image0)[0]
		sizeY = np.shape(image0)[1]
		
		m1 = np.ma.median(image0[100:200,100:200].flatten())
		m2 = np.ma.median(image0[sizeX-200:sizeX-100,100:200].flatten())
		m3 = np.ma.median(image0[100:200,sizeY-200:sizeY-100].flatten())
		m4 = np.ma.median(image0[sizeX-200:sizeX-100,sizeY-200:sizeY-100].flatten())
		moy = (m1+m2+m3+m4)/4.
		
		median1.append(m1-moy)
		median2.append(m2-moy)
		median3.append(m3-moy)
		median4.append(m4-moy)
	print time.time()-t0, "seconds"
	
	#for non uniform background, to detect variations (added sept 2011 for F Kugel)
	median1 = median1 - np.mean(median1)
	median2 = median2 - np.mean(median2)
	median3 = median3 - np.mean(median3)
	median4 = median4 - np.mean(median4)

	print
	print
	print '--- CHECKING DYNAMIC RANGE OF CALIBRATED IMAGES ---------------------'
	
	plt.ion()
	fig = plt.figure()
	fig.canvas.set_window_title("Dynamic range") 
	plt.plot(maxi,label='Max')
	plt.plot(mini,label='Min')
	plt.plot(dyn,label='Dynamic range')
	plt.title("Min, Max and Max-Min")
	plt.xlabel("image number")
	plt.grid()
	plt.draw()

	fx, fy = astro.get_window_position("Dynamic range")
	astro.move_window("Dynamic range", [sx, fy])
	astro.set_focus(u"C:\\WINDOWS\\System32\\cmd.exe")

	while 1:
		try:
			th1 = np.float(raw_input("\nEnter threshold value. All images having the difference between max and min (=dynamic range) below this value are rejected:"))
			break
		except:
			print "please enter a number !"
	for i,m in enumerate(dyn):
		if m<=th1:
			rej1.append(i)

	rej1.sort()
	plt.close()

	xx = []
	print
	for yy in rej1:
		xx.append(yy+1)
	print "Images to be removed:",xx

	print
	print
	print '--- CHECKING UNNIFORMITY OF CALIBRATED IMAGES -----------------------'
			
	fig = plt.figure()
	fig.canvas.set_window_title("Background uniformity") 
	plt.plot(median1)
	plt.plot(median2)
	plt.plot(median3)
	plt.plot(median4)
	plt.title("Difference between median values\nfrom different image zones")
	plt.xlabel("image number")
	plt.grid()
	plt.draw()

	fx, fy = astro.get_window_position("Background uniformity")
	astro.move_window("Background uniformity", [sx, fy])
	astro.set_focus(u"C:\\WINDOWS\\System32\\cmd.exe")

	while 1:
		try:
			th2 = np.float(raw_input("\nEnter threshold value. All images with background non-uniformity higher than this value are rejected:"))
			break
		except:
			print "please enter a number !"
	for i,m in enumerate(median1):
		if np.abs(m)>=th2:
			rej2.append(i)

	for i,m in enumerate(median2):
		if np.abs(m)>=th2:
			rej2.append(i)

	for i,m in enumerate(median3):
		if np.abs(m)>=th2:
			rej2.append(i)

	for i,m in enumerate(median4):
		if np.abs(m)>=th2:
			rej2.append(i)

	rej2 = list(set(rej2))
	rej2.sort()
	plt.close()
	
	xx = []
	print
	for yy in rej2:
		xx.append(yy+1)
	print "Images to be removed:",xx
		
	print
	print
	print '--- ADDITIONAL IMAGES TO BE REMOVED ---------------------------------'
	while 1:
		try:
			im = int(raw_input("Please enter the numbers of additional images to be removed:"))
			rej3.append(im-1)
		except:
			break
	rej3 = list(set(rej3))
	rej3.sort()
	
	#------ all removed images ------------------------------------

	rejected = rej1+rej2+rej3
	rejected = list(set(rejected))
	rejected.sort()

	print
	print
	print '--- FINAL LIST OF IMAGES TO BE REMOVED ------------------------------'
	xx = []
	for yy in rejected:
		xx.append(yy+1)
	print xx

	good_Imagelist = [Imagelist[i] for i in range(len(Imagelist)) if i not in rejected]

	#------ writing results to output file ---------------------------------
	#names of output files

	f = open(outputname, 'w')
	f.write('date = '+str((datetime.datetime.now()).strftime("%Y-%m-%d %H:%M:%S"))+'\n')
	f.write("Working directory:\n"+(os.path.split(Imagelist[0])[0]).encode('iso_8859_1')+"\n\n")
	f.write("-------------------------------------------------\n")
	f.write("      User inputs for images selection\n")
	f.write("-------------------------------------------------\n")
	f.write("Dynamic range threshold:\t"+str(th1)+"\n")
	f.write("Background uniformity threshold:\t"+str(th2)+"\n")
	f.write("Images rejected by user:\t")
	if len(rej3)==0:
		f.write('none\n')
	else:
		for i in range(len(rej3)-1):
			f.write(str(rej3[i]+1)+',')
		f.write(str(rej3[-1]+1)+"\n")
	f.write("\n")
	
	f.write("-------------------------------------------------\n")
	f.write("      Input images are\n")
	f.write("-------------------------------------------------\n")
	f.write('Image\tImage status\tImage name\tMin value\tMax value\tDynamic range=Max-Min\tSky background 1\tSky background 2\tSky background 3\tSky background 4\n')
	for i,im in enumerate(Imagelist):
		f.write(str(i+1)+'\t')
		if i not in rejected:
			f.write("ok\t")
		else:
			f.write("rejected (")
			test = (i in rej1)*100 + (i in rej2)*10 + (i in rej3)
			if test == 100:
				f.write("dyn)\t")
			elif test == 10:
				f.write("bkg)\t")
			elif test == 1:
				f.write("usr)\t")
			elif test == 11:
				f.write("bkg+usr)\t")
			elif test == 101:
				f.write("dyn+usr)\t")
			elif test == 110:
				f.write("dyn+bkg)\t")
			elif test == 111:
				f.write("dyn+bkg+usr)\t")
		f.write(im.split('\\')[-1]+'\t'+str(mini[i])+'\t'+str(maxi[i])+'\t'+str(dyn[i])+'\t'+str(median1[i])+'\t'+str(median2[i])+'\t'+str(median3[i])+'\t'+str(median4[i])+'\n')
	f.close()

	return good_Imagelist