#include "dll.h"

extern "C"
{
   __declspec(dllexport) int matching_pairs(double dist, int dim1, double* x1, double* y1, int dim2, double* x2, double* y2, int& dim, int* z1, int*z2)
   {
       /*--------------------------------------------------------------------------------
       //   This function calculates the matching pairs between two lists of stars
       //   - first list has dim1 stars with coordinates (x1,y1)
       //   - second list has dim2 stars with coordinates (x2,y2)\
       //   a pair of stars is matching if abs(x2-x1)+abs(y2-y1) < dist
       //--------------------------------------------------------------------------------*/

        double dd, dd2;

        //--- no matching pair at start ---
        dim = 0;

        //--- start with 0 so that it is re-initialised at the end of the loop only if needed
        //and not at the beginning of all loops ---
        int nb=0;

        for (int i=0; i<dim1; i++)
        {
            for (int j=0; j<dim2; j++)
            {
                //--- cascaded tests ---
                if (x2[j]-x1[i]<dist)
                    if (x2[j]-x1[i]>-dist)
                        if (y2[j]-y1[i]<dist)
                            if (y2[j]-y1[i]>-dist)
                            {
                                dd2 = fabs(x2[j]-x1[i]) + fabs(y2[j]-y1[i]);

                                if (nb>0)   //then a matching star j is already known for star i
                                {
                                    if (dd2 <dd)
                                    {
                                        dd = dd2;
                                        z1[dim] = i;
                                        z2[dim] = j;
                                    }
                                }
                                else
                                {
                                    dd = dd2;
                                    z1[dim] = i;
                                    z2[dim] = j;
                                    nb++;
                                }
                            }
            }
            if (nb>0)
            {
                dim++;
                nb=0;
            }
        }

      return(0);
   }
}
