/*****************************************************************************
 *	Includes / define
 ****************************************************************************/
//system includes
#include	<math.h>

//other includes
#include	"dll.h"

/*****************************************************************************
 *	Sigma clipping function
 ****************************************************************************/

double sigma_clip(double * buffer, int dim, double sigma, int iterations)
{

    int filtered=0;
    double mean, std, result;

    int *filter;
    filter = new int[dim];
    for(int i=0; i<dim; i++)
        filter[i] = 0;

    for(int k=0; k<iterations;k++)
    {
        //calculation of mean + standard deviation
        mean = 0.0;
        for (int p=0; p<dim; p++)
            if (filter[p]==0)
                mean = mean + buffer[p];

        mean = mean / (dim-filtered);

        std = 0.0;
        for (int p=0; p<dim; p++)
            if (filter[p]==0)
                std = std + (buffer[p]-mean)*(buffer[p]-mean);

        std = std / (dim-filtered);
        std = sqrt(std);

        //sigma clipping test
        for (int p=0; p<dim; p++)
            if(fabs(buffer[p]-mean) > sigma*std)
                filter[p] = 1;

        filtered = 0;
        for (int p=0; p<dim; p++)
            filtered = filtered + filter[p];
    }

    //after filtering has been done, mean is re-calculated
    result = 0.0;
    for (int p=0; p<dim; p++)
        if (filter[p]==0)
            result = result + buffer[p];

    result = result / (dim-filtered);

    return(result);
}
